/***************************************************************************
 *   Copyright (C) 2007 by Lisandro Damián Nicanor Pérez Meyer   *
 *   perezmeyer@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "building.h"

Building::Building() : GraphicPrimitive()
{
	// Set the matrices
	bodyMatrix.setValue(0, 0, 0.5);
	bodyMatrix.setValue(1, 2, -100.0);

	topLeftWindowMatrix.setValue(0, 0, 0.1);
	topLeftWindowMatrix.setValue(0, 2, -25.0);
	topLeftWindowMatrix.setValue(1, 1, 0.1);
	topLeftWindowMatrix.setValue(1, 2, -160.0);

	topRightWindowMatrix.setValue(0, 0, 0.1);
	topRightWindowMatrix.setValue(0, 2, 25.0);
	topRightWindowMatrix.setValue(1, 1, 0.1);
	topRightWindowMatrix.setValue(1, 2, -160.0);

	bottomLeftWindowMatrix.setValue(0, 0, 0.1);
	bottomLeftWindowMatrix.setValue(0, 2, -25.0);
	bottomLeftWindowMatrix.setValue(1, 1, 0.1);
	bottomLeftWindowMatrix.setValue(1, 2, -80.0);

	bottomRightWindowMatrix.setValue(0, 0, 0.1);
	bottomRightWindowMatrix.setValue(0, 2, 25.0);
	bottomRightWindowMatrix.setValue(1, 1, 0.1);
	bottomRightWindowMatrix.setValue(1, 2, -80.0);

	leftDoorPanelMatrix.setValue(0, 0, 0.05);
	leftDoorPanelMatrix.setValue(0, 2, -5.0);
	leftDoorPanelMatrix.setValue(1, 1, 0.1);
	leftDoorPanelMatrix.setValue(1, 2, -10.0);

	rightDoorPanelMatrix.setValue(0, 0, 0.05);
	rightDoorPanelMatrix.setValue(0, 2, 5.0);
	rightDoorPanelMatrix.setValue(1, 1, 0.1);
	rightDoorPanelMatrix.setValue(1, 2, -10.0);
}


void Building::draw(Matrix3X3 * incomingMatrix, QPainter * painter)
{
	Matrix3X3 * temp;

	temp = incomingMatrix->multiplyToTheRight(bodyMatrix);
	body.draw(temp, painter);
	delete temp;

	temp = incomingMatrix->multiplyToTheRight(topLeftWindowMatrix);
	topLeftWindow.draw(temp, painter);
	delete temp;

	temp = incomingMatrix->multiplyToTheRight(topRightWindowMatrix);
	topRightWindow.draw(temp, painter);
	delete temp;

	temp = incomingMatrix->multiplyToTheRight(bottomLeftWindowMatrix);
	bottomLeftWindow.draw(temp, painter);
	delete temp;

	temp = incomingMatrix->multiplyToTheRight(bottomRightWindowMatrix);
	bottomRightWindow.draw(temp, painter);
	delete temp;

	temp = incomingMatrix->multiplyToTheRight(leftDoorPanelMatrix);
	leftDoorPanel.draw(temp, painter);
	delete temp;

	temp = incomingMatrix->multiplyToTheRight(rightDoorPanelMatrix);
	rightDoorPanel.draw(temp, painter);
	delete temp;
}


