/***************************************************************************
 *   Copyright (C) 2007 by Lisandro Damián Nicanor Pérez Meyer             *
 *   perezmeyer@gmail.com                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef PINE_H
#define PINE_H

#include "graphicprimitive.h"
#include "triangle.h"
#include "square.h"

/**
This class generates a Pine

	@author Lisandro Damián Nicanor Pérez Meyer <perezmeyer@gmail.com>
*/
class Pine : public GraphicPrimitive
{
public:
	Pine();

	void draw(Matrix3X3 * incomingMatrix, QPainter * painter);

private:
	Square trunk;
	Triangle leaves;

	Matrix3X3 trunkMatrix;
	Matrix3X3 leavesMatrix;
};

#endif
