/***************************************************************************
 *   Copyright (C) 2007 by Lisandro Damián Nicanor Pérez Meyer             *
 *   perezmeyer@gmail.com                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef PRACTICO2_H
#define PRACTICO2_H

#include <QMainWindow>
#include "ui/ui_mainwindow.h"

class Practico2 : public QMainWindow
{
	Q_OBJECT
public:
	Practico2(QWidget * parent = 0);

public slots:

	/// Add a figure to the scene
	/**
		When the addQPushButton's clicked() signal is emmited, this function will
		check wich figue has been selected and it will add it to th scene and
		the figures list.
	*/
	void addFigureToScene();

	/// Reset the sliders
	void resetSliders(double xDisplacement, double yDisplacement,
	                  double rotationAngle, double xScale, double yScale);

private:
	Ui::MainWindow mainWindow;
	static const int building = 0;
	static const int pine = 1;
	static const int rocket = 2;
	static const int square = 3;
	static const int triangle = 4;

	int buildingCount;
	int pineCount;
	int rocketCount;
	int squareCount;
	int triangleCount;
};

#endif
